//
//  FirstViewController.m
//  TabBar Navigation
//
//  Created by Holger Hinzberg on 29.02.12.
//  Copyright (c) 2012 Cocoa-Coding. All rights reserved.
//

#import "FirstViewController.h"

@interface FirstViewController ()

@end

@implementation FirstViewController
@synthesize redSlider;
@synthesize greenSlider;
@synthesize blueSlider;
@synthesize hexValueLabel;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self)
    {
        self.title = @"First View";
        self.tabBarItem.image 
        = [UIImage imageNamed:@"tabicon"];
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];    
    [self setBackgroundColor];
}

- (void)viewDidUnload
{
    [self setRedSlider:nil];
    [self setGreenSlider:nil];
    [self setBlueSlider:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

-(void)setBackgroundColor
{
    // Die Werte von den Schiebereglern holen.
    float greenValue = greenSlider.value;
    float redValue = redSlider.value;
    float blueValue = blueSlider.value;
    
    // Zeichenkette erzeugen.
    NSString *hexString =
    [self generateHexStringWithRed:redValue
                             green:greenValue
                              blue:blueValue];
    
    NSLog(@"%@",hexString);
    
    
    
    
    
    hexValueLabel.text = hexString;
    
    // Die Werte umrechnen.
    greenValue = greenValue / 255.0;
    redValue = redValue / 255.0;
    blueValue = blueValue / 255.0;
    
    // Ein UIColor-Objekt konfigurieren
    UIColor *bgColor = [UIColor colorWithRed:redValue
                                       green:greenValue
                                        blue:blueValue
                                       alpha:1.0f];
    
    // Die Farbe des View setzen.
    [self.view setBackgroundColor:bgColor];
}

-(NSString *)generateHexStringWithRed:(double)redValue
                                green:(double)greenValue
                                 blue:(double)blueValue
{
    // Farbanteil in einen hexadezimalen 
    // Wert umwandeln.
    NSString *greenString 
    = [NSString stringWithFormat:@"%02x",
       (int) greenValue];
    
    NSString *redString 
    = [NSString stringWithFormat:@"%02x",
       (int) redValue];
    
    NSString *blueString 
    = [NSString stringWithFormat:@"%02x",
       (int) blueValue];
    
    // Einen NSMutableString mit #.
    NSMutableString *hexString 
    = [NSMutableString stringWithString:@"#"];
    
    // Einzelne Farbanteile zusammenbauen
    [hexString appendString:redString];
    [hexString appendString:greenString];
    [hexString appendString:blueString];
    
    // In Großbuchstaben umwandeln.
    return [hexString uppercaseString];
}


- (IBAction)redSliderMoved:(id)sender
{
    [self setBackgroundColor];
}

- (IBAction)greenSliderMoved:(id)sender
{
    [self setBackgroundColor];
}

- (IBAction)blueSliderMoved:(id)sender
{
    [self setBackgroundColor];
}
@end
